<script lang="ts">
import { defineComponent } from "vue";

export default defineComponent({
  props: {
    version: { type: String, default: "" },
    versionHash: { type: String, default: "" },
    mergeRequest: { type: Number, default: 0 },
    mergeRequestBranch: { type: String, default: "" },
    provider: { type: String, default: "gitlab" },
    providerUrl: { type: String, default: "gitlab.com" },
    repo: { type: String, default: "" },
  },
  computed: {
    versionLabel() {
      var label = "";
      if (this.version) {
        label = this.version;
        if (this.versionHash) {
          label = `${label}+${this.versionHash}`;
        }
      } else if (this.versionHash) {
        label = this.versionHash;
      } else {
        label = `${this.repo} [no version set]`;
      }
      if (this.mergeRequestBranch) {
        label = `${label} [${this.mergeRequestBranch}]`;
      }
      return label;
    },
    versionLink() {
      var link = `https://${this.providerUrl}/${this.repo}`;
      if (this.mergeRequest) {
        link = `${link}/-/merge_requests/${this.mergeRequest}`;
      } else if (this.versionHash && !this.mergeRequest) {
        link = `${link}/-/commit/${this.versionHash}`;
      } else if (this.version) {
        link = `${link}/-/releases/${this.version}`;
      }
      return link;
    },
  },
});
</script>

<template>
  <div>
    <p>
      <a :href="versionLink" target="_blank">{{ versionLabel }}</a>
    </p>
  </div>
</template>

<style scoped>
div p,
div p a {
  color: grey;
  text-decoration: none;
  font-size: 0.75rem;
  text-align: center;
}
</style>
